commit e2bbdded9029cc121b6f81f78733c0f9d4832b3a
Author: Michele Tartara <mtartara@google.com>
Date:   Fri Aug 30 14:25:22 2013 +0200

    Sync build_chroot with buildbot slack role
    
    Keep the build_chroot script as similar as possible to the buildbot's slack role
    for squeeze.
    
    Signed-off-by: Michele Tartara <mtartara@google.com>
    Reviewed-by: Klaus Aehlig <aehlig@google.com>

diff --git a/devel/build_chroot b/devel/build_chroot
index 6f8df03..7f53bc9 100755
--- a/devel/build_chroot
+++ b/devel/build_chroot
@@ -8,7 +8,7 @@
 : ${CHROOT_FINAL_HOOK:=/bin/true}
 # Additional Variables taken from the environmen
 # DATA_DIR
-# CHROOT_EXTRA_DEBIAN_PACKAGES    
+# CHROOT_EXTRA_DEBIAN_PACKAGES
 
 #Automatically generated variables
 CHROOTNAME=$DIST_RELEASE-$ARCH
@@ -119,84 +119,67 @@ echo "deb http://backports.debian.org/debian-backports" \
 in_chroot -- \
   apt-get update
 
-#Install selected packages from backports
-in_chroot -- \
-  $APT_INSTALL -t squeeze-backports \
-    git \
-    git-email \
-    vim
-
-in_chroot -- \
-  $APT_INSTALL python-setuptools build-essential python-dev sudo automake \
-               fakeroot rsync locales less
-
-echo "en_US.UTF-8 UTF-8" >> $CHDIR/etc/locale.gen
 
+# do not install libghc6-network-dev, since it's too old, and just
+# confuses the dependencies
 in_chroot -- \
-  locale-gen
+  $APT_INSTALL \
+    autoconf automake \
+    ghc cabal-install \
+    libghc6-curl-dev \
+    libghc6-parallel-dev \
+    libghc6-text-dev \
+    libghc6-vector-dev \
+    libpcre3-dev \
+    hlint hscolour pandoc \
+    graphviz socat qemu-utils \
+    python-docutils \
+    python-simplejson \
+    python-pyparsing \
+    python-pyinotify \
+    python-pycurl \
+    python-ipaddr \
+    python-yaml \
+    python-paramiko
 
 in_chroot -- \
-  $APT_INSTALL lvm2 ssh bridge-utils iproute iputils-arping \
-               ndisc6 python python-pyopenssl openssl \
-               python-pyparsing python-simplejson \
-               python-pyinotify python-pycurl python-yaml python-mock \
-               socat fping
+  $APT_INSTALL python-setuptools python-dev build-essential
 
 in_chroot -- \
-  $APT_INSTALL python-paramiko qemu-utils
+  easy_install \
+    logilab-astng==0.20.1 \
+    logilab-common==0.50.3 \
+    mock==1.0.1 \
+    pylint==0.25.1
 
 in_chroot -- \
-  easy_install affinity bitarray ipaddr
-
-#Haskell packages
-in_chroot -- \
-  $APT_INSTALL ghc6 \
-               libghc6-parallel-dev libghc6-deepseq-dev \
-               libghc6-curl-dev
-
-in_chroot -- \
-  $APT_INSTALL cabal-install
+  easy_install \
+    sphinx==1.1.3 \
+    pep8==1.2 \
+    coverage==3.4 \
+    bitarray==0.8.0
 
 in_chroot -- \
   cabal update
 
 in_chroot -- \
-  $APT_INSTALL libpcre3-dev
-
-in_chroot -- \
   cabal install --global \
     network==2.3 \
     regex-pcre==0.94.2 \
     hinotify==0.3.2 \
     hslogger==1.1.4 \
-    attoparsec==0.10.1.1\
     quickcheck==2.5.1.1 \
+    attoparsec==0.10.1.1 \
     crypto==4.2.4 \
-    monadcatchio-transformers==0.2.2.0 \
+    MonadCatchIO-transformers==0.2.2.0 \
     mtl==2.0.1.0 \
     hashable==1.1.2.0 \
     case-insensitive==0.3 \
     parsec==3.0.1 \
     network==2.3 \
     snap-server==0.8.1 \
-    text==0.11.3.0 \
-    vector==0.9.1 \
-    json==0.4.4 \
-    process==1.0.1.2
+    json==0.4.4
 
-#Python development tools
-in_chroot -- \
-  $APT_INSTALL pandoc python-epydoc graphviz
-
-in_chroot -- \
-  easy_install sphinx==1.1.3 \
-               logilab-common \
-               logilab-astng==0.23.1 \
-               pylint==0.25.1 \
-               pep8==1.2 \
-               coverage
-
-#Haskell development tools
 in_chroot -- \
   cabal install --global \
     hunit==1.2.5.2 \
@@ -209,11 +192,45 @@ in_chroot -- \
     test-framework-quickcheck2==0.2.12.3
 
 in_chroot -- \
+  cabal install --global cabal-file-th
+
+in_chroot -- \
   cabal install --global shelltestrunner
 
+#Install selected packages from backports
+in_chroot -- \
+  $APT_INSTALL -t squeeze-backports \
+    git \
+    git-email \
+    vim
+
+in_chroot -- \
+  $APT_INSTALL sudo fakeroot rsync locales less
+
+echo "en_US.UTF-8 UTF-8" >> $CHDIR/etc/locale.gen
+
+in_chroot -- \
+  locale-gen
+
+in_chroot -- \
+  $APT_INSTALL lvm2 ssh bridge-utils iproute iputils-arping \
+               ndisc6 python python-pyopenssl openssl \
+               python-mock \
+               socat fping
+
+in_chroot -- \
+  $APT_INSTALL qemu-utils
+
+in_chroot -- \
+  easy_install affinity
+
+#Python development tools
+in_chroot -- \
+  $APT_INSTALL pandoc python-epydoc
+
 #Tools for creating debian packages
 in_chroot -- \
-  $APT_INSTALL python-docutils debhelper quilt
+  $APT_INSTALL debhelper quilt
 
 # extra debian packages
 