commit 9228aff8315497680a2ddf619354de561d1c8c73
Author: Nikos Skalkotos <skalkoto@grnet.gr>
Date:   Sun Aug 4 18:10:12 2013 +0300

    Update documentation to reflect the changes made

diff --git a/docs/usage.rst b/docs/usage.rst
index 679b319..5dd73d4 100644
--- a/docs/usage.rst
+++ b/docs/usage.rst
@@ -17,42 +17,47 @@ snf-image-creator receives the following options:
 
 .. code-block:: console
 
-   $ snf-image-creator --help
-   Usage: snf-image-creator [options] <input_media>
-   
-   Options:
-     --version             show program's version number and exit
-     -h, --help            show this help message and exit
-     -o FILE, --outfile=FILE
-                           dump image to FILE
-     -f, --force           overwrite output files if they exist
-     -s, --silent          output only errors
-     -u FILENAME, --upload=FILENAME
-                           upload the image to the storage service with name FILENAME
-     -r IMAGENAME, --register=IMAGENAME
-                           register the image with the compute service as IMAGENAME
-     -m KEY=VALUE, --metadata=KEY=VALUE
-                           add custom KEY=VALUE metadata to the image
-     -t TOKEN, --token=TOKEN
-                           use this authentication token when
-                           uploading/registering images
-     -a URL, --authentication-url=URL
-                           use this authentication URL when uploading/registering
-                           images
-     -c CLOUD, --cloud=CLOUD
-                           use this saved cloud account to authenticate against a
-                           cloud when uploading/registering images
-     --print-sysprep       print the enabled and disabled system preparation
-                           operations for this input media
-     --enable-sysprep=SYSPREP
-                           run SYSPREP operation on the input media
-     --disable-sysprep=SYSPREP
-                           prevent SYSPREP operation from running on the input
-                           media
-     --no-sysprep          don't perform any system preparation operation
-     --no-shrink           don't shrink any partition
-     --public              register image with the compute service as public
-     --tmpdir=DIR          create large temporary image files under DIR
+  $ snf-image-creator --help
+  Usage: snf-image-creator [options] <input_media>
+
+  Options:
+    --version             show program's version number and exit
+    -h, --help            show this help message and exit
+    -o FILE, --outfile=FILE
+                          dump image to FILE
+    -f, --force           overwrite output files if they exist
+    -s, --silent          output only errors
+    -u FILENAME, --upload=FILENAME
+                          upload the image to the cloud with name FILENAME
+    -r IMAGENAME, --register=IMAGENAME
+                          register the image with a cloud as IMAGENAME
+    -m KEY=VALUE, --metadata=KEY=VALUE
+                          add custom KEY=VALUE metadata to the image
+    -t TOKEN, --token=TOKEN
+                          use this authentication token when
+                          uploading/registering images
+    -a URL, --authentication-url=URL
+                          use this authentication URL when uploading/registering
+                          images
+    -c CLOUD, --cloud=CLOUD
+                          use this saved cloud account to authenticate against a
+                          cloud when uploading/registering images
+    --print-syspreps      print the enabled and disabled system preparation
+                          operations for this input media
+    --enable-sysprep=SYSPREP
+                          run SYSPREP operation on the input media
+    --disable-sysprep=SYSPREP
+                          prevent SYSPREP operation from running on the input
+                          media
+    --print-sysprep-params
+                          print the needed sysprep parameters for this input
+                          media
+    --sysprep-param=SYSPREP_PARAMS
+                          Add KEY=VALUE system preparation parameter
+    --no-sysprep          don't perform any system preparation operation
+    --no-shrink           don't shrink any partition
+    --public              register image with the cloud as public
+    --tmpdir=DIR          create large temporary image files under DIR
 
 Most input options are self-describing. If you want to save a local copy of
 the image you create, provide a filename using the *-o* option. To upload the
@@ -298,10 +303,11 @@ Limitations
 Supported operating systems
 ---------------------------
 
-*snf-image-creator* can only fully function on input media hosting *Linux*
-systems. The program will detect the needed metadata and you may use it to
-upload and register other *Unix* or *Windows* images, but you cannot use it to
-shrink them or perform system preparation operations.
+*snf-image-creator* can only fully function on input media hosting *Linux*,
+*FreeBSD* (tested on version 9.1) and *Windows* (Server 2008 R2 and Server
+2012) systems. The program will detect the needed metadata and you may use it
+to upload and register other *Unix* images, but you cannot use it to shrink
+them or perform system preparation operations.
 
 Logical Volumes
 ---------------
@@ -330,6 +336,13 @@ if a system can boot with para-virtualized disk controller by launching it with
 kvm using the *if=virtio* option (see the kvm command in the
 `Creating a new image`_ section).
 
+For Windows and FreeBSD systems, the needed drivers need to be manually
+downloaded and installed on the media before the image creation process takes
+place. For *FreeBSD* the virtio drivers can be found
+`here <http://people.freebsd.org/~kuriyama/virtio/>`_. For Windows the drivers
+are hosted by the
+`Fedora Project <http://alt.fedoraproject.org/pub/alt/virtio-win/latest/images/>`_.
+
 Some caveats on image creation
 ==============================
 